Ruby - Bug #20900

Net.send(:remove_const, :HTTPSession) does not emit warnings
11/19/2024 02:41 AM - yahonda (Yasuo Honda)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 3.3.6 (2024-11-05 revision Backport: 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3:
75015d4c1f) [x86_64-linux] UNKNOWN

Description

After https:/github.com/ruby/net-http/pull/189 has been merged and cherry-picked to Ruby master branch,
Net.send(:remove_const, :HTTPSession) gets the NameError. This code should emit warnings against Ruby 3.3 or earlier versions
of Ruby but actually it does not.

$ ruby -v
ruby 3.4.0dev (2024-11-18T15:04:50Z :detached: 4a7ac694e5) +PRISM [x86_64-1inux]
S irb —-w

snip ...
irb(main) : 001> require 'net/http'
=> true
irb(main) :002> Net.send(:remove_const, :HTTPSession)
(irb) :2:in 'Module#remove_const': constant Net::HTTPSession not defined (NameError)

from (irb):2:in '<main>'

from <internal:kernel>:168:in 'Kernel#loop'

from /home/yahonda/.rbenv/versions/trunk/lib/ruby/gems/3.4.0+1/gems/irb-1.14.1/exe/irb:9:in '<top
(required) >'

from /home/yahonda/.rbenv/versions/trunk/bin/irb:25:in 'Kernel#load'

from /home/yahonda/.rbenv/versions/trunk/bin/irb:25:in '<main>'
irb (main) : 003>

Steps to reproduce
Here are the steps to see if the warnings are emitted against Ruby 3.3.

$ ruby -v
ruby 3.3.6 (2024-11-05 revision 75015d4c1f) [x86_64-linux]
$irb -w

require 'net/http'
Net::HTTPSession
Net.send (:remove_const, :HTTPSession)

Expected behavior

Both of Net::HTTPSession and Net.send(:remove_const, :HTTPSession) should emit the warning: constant Net::HTTPSession is
deprecated .

Actual behavior

Only Net::HTTPSession emits the warnings. Net.send(:remove_const, :HTTPSession) does not emit any warnings.

$ irb -w

irb(main) : 001> require 'net/http'

irb (main) : 002>

=> true

irb (main) :003> Net::HTTPSession

(irb) :3: warning: constant Net::HTTPSession is deprecated
=> Net::HTTP

irb(main) : 004> Net.send(:remove_const, :HTTPSession)

=> Net::HTTP

06/20/2025 12



https://github.com/ruby/net-http/pull/189

irb (main) : 005>

Associated revisions

Revision 9¢777f282f8482400d4b0c7993d520c18cb1b652 - 11/19/2024 03:43 AM - nobu (Nobuyoshi Nakada)

[Bug #20900] Warn deprecated constant when removing

Revision 9¢777f282f8482400d4b0c7993d520c18cb1b652 - 11/19/2024 03:43 AM - nobu (Nobuyoshi Nakada)

[Bug #20900] Warn deprecated constant when removing

Revision 9¢777f28 - 11/19/2024 03:43 AM - nobu (Nobuyoshi Nakada)

[Bug #20900] Warn deprecated constant when removing

History

#1 - 11/19/2024 02:43 AM - yahonda (Yasuo Honda)
| wish the :remove_const should also emit the warnings so that at least WebMock users can be aware of this change.
Refer to:

https://github.com/bblimke/webmock/blob/9ff63ac7c845a75278e43236e0128e197f597462/lib/webmock/http_lib_adapters/net_http.rb#L 18
https://github.com/bblimke/webmock/blob/9ff63ac7c845a75278e43236e0128e197f597462/lib/webmock/http_lib_adapters/net_http.rb#L 25

#2 - 11/19/2024 03:28 AM - hsbt (Hiroshi SHIBATA)
| restore HTTPSession at https://github.com/ruby/net-http/pull/191

#3 - 11/19/2024 04:16 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset git|9¢c777{282{8482400d4b0c7993d520¢18cb1b652.

[Bug #20900] Warn deprecated constant when removing

#4 - 11/19/2024 09:03 AM - Earlopain (Earlopain _)

I think warning on removal is a good thing. It makes compatibility code in webmock a bit more involved but that's totally fine.
hsbt (Hiroshi SHIBATA) wrote in #note-2:

| restore HTTPSession at https://github.com/ruby/net-http/pull/191

You added it as Net::HTTP::HTTPSession, it used to be just Net::HTTPSession.

#5 - 11/19/2024 09:35 AM - hsbt (Hiroshi SHIBATA)

You added it as Net::HTTP::HTTPSession, it used to be just Net::HTTPSession.

| fixed that at https://github.com/ruby/ruby/commit/716ea630dbd6cea62049a7a438d7d4f4f{84d4aae

#6 - 11/19/2024 10:00 AM - Earlopain (Earlopain _)
hsbt (Hiroshi SHIBATA) wrote in #note-5:

You added it as Net::HTTP::HTTPSession, it used to be just Net::HTTPSession.

| fixed that at https:/github.com/ruby/ruby/commit/716ea630dbd6cea62049a7a438d7d4f4f{84d4aae

Thanks!
